package zero1hd.rhythmbullet.entity;


import java.util.HashMap;

import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.utils.Array;

import zero1hd.rhythmbullet.entity.ally.Laser;
import zero1hd.rhythmbullet.entity.enemies.Bar;
import zero1hd.rhythmbullet.entity.enemies.Flake;
import zero1hd.rhythmbullet.entity.enemies.Pellet;
import zero1hd.rhythmbullet.entity.enemies.Shard;
import zero1hd.rhythmbullet.entity.enemies.VoidCircle;

public class EntityController {
	private AssetManager assets;
	private Preferences prefs;
	private Stage stage;
	
	public Array<Entity> activeAllies;
	public Array<Entity> activeEnemies;
	
	public EntityFrame<VoidCircle> voidCircle;
	public EntityFrame<Pellet> pellet;
	public EntityFrame<Shard> shard;
	public EntityFrame<Bar> bar;
	public EntityFrame<Flake> flake;
	
	public EntityFrame<Laser> laser;
	
	private HashMap<EntityIndex, EntityFrame<? extends Entity>> index = new HashMap<>();
	
	public EntityController(AssetManager assetManager, Preferences preferences, Stage stage) {
		activeAllies = new Array<Entity>();
		activeEnemies = new Array<Entity>();
		this.assets = assetManager;
		this.prefs = preferences;
		this.stage = stage;
		
		setup();
	}
	
	private void setup() {
		index.put(EntityIndex.VOID_CIRCLE, (voidCircle = new EntityFrame<>(this, VoidCircle.class)));
		index.put(EntityIndex.PELLET, pellet = new EntityFrame<>(this, Pellet.class));
		index.put(EntityIndex.SHARD, shard = new EntityFrame<>(this, Shard.class));
		index.put(EntityIndex.BAR, bar = new EntityFrame<>(this, Bar.class));
		index.put(EntityIndex.FLAKE, flake = new EntityFrame<>(this, Flake.class));
		
		index.put(EntityIndex.LASER, laser = new EntityFrame<>(this, Laser.class));
	}
	
	public HashMap<EntityIndex, EntityFrame<? extends Entity>> getIndex() {
		return index;
	}
	
	public Stage getStage() {
		return stage;
	}
	
	public AssetManager getAssets() {
		return assets;
	}
	
	public Preferences getPrefs() {
		return prefs;
	}
}
